//Setup
$.mobile.defaultPageTransition   = 'fade';
$.mobile.defaultDialogTransition = 'fade';
$.mobile.toolbar.prototype.options.updatePagePadding = true;
$.mobile.toolbar.prototype.options.hideDuringFocus = "";
$.mobile.toolbar.prototype.options.tapToggle = false;


///////////////////////////////////////////
// side_menu definitie
///////////////////////////////////////////

var a_side_menu = [
	{target:'marine_table', label:'Marine_table'},
	{target:'marine_map', 	label:'Marine_map'},
];


///////////////////////////////////////////
// mendu definitie
///////////////////////////////////////////

var a_menu = [];

a_menu.push({id:'home', 		label:'Beaches', 			title:'Beaches',		coord:'27,397,181,551'});
a_menu.push({id:'map', 			label:'Map', 				title:'Map',			coord:'6,144,160,298'});
a_menu.push({id:'favorites', 	label:'Favorites',			title:'Favorites',		coord:'261,26,415,180'});
a_menu.push({id:'about', 		label:'About', 				title:'About',			coord:'440,184,607,338'});

///////////////////////////////////////////
// utc_diff (diff between local and utc time
///////////////////////////////////////////

	var utc_diff = 3;						// default op zomertijd, indien geen verbinding

///////////////////////////////////////////
// jump table
///////////////////////////////////////////

!(function (app){
	app.routes = {
		'#splash' 			: app.content.startup,
		'#home' 			: app.content.home,
		'#favorites' 		: app.content.favorites,
		'#map' 				: app.content.map,
		'#map_region'		: app.content.map_region,
		'#about' 			: app.content.about,
		'#beach' 			: app.content.beach,
		'#beach_detail'		: app.content.beach_detail,
		'#marine_table'		: app.content.marine_table,
		'#marine_map'		: app.content.marine_map,
		'#beach_weather'	: app.content.beach_weather,
		'#beach_map'		: app.content.beach_map,
		'#html'				: app.content.html,
		'#photo'			: app.content.photo,
		'#photos'			: app.content.photos
	};


///////////////////////////////////////////
// route
///////////////////////////////////////////

	app.route = function () {
		if (app.routes[params.hash]) {
			params.active_menu = a_menu.find(function (i){return "#"+i.id == params.hash}) || {};		// gekozen menu optie
			app.routes[params.hash]();
		} else {
			location.hash = "splash";
		}
	};


///////////////////////////////////////////
// default side menu met aanroep
// naar eigen prog
///////////////////////////////////////////

	app.side_menu = function(opts) {
		var options = opts || a_side_menu;

		var template = $();


		$('#sidemenu_content').empty();

		var ul = $('<ul>', {
			'id': 'side_menu_list',
		});

//$('#marine_map_legend_container').empty();

		$.each(options, function(key, value ) {
			var li = $('<li>');
			var a = $('<a>', {
				text: value.label,
				href: "#" + value.target,
				class: value.class,
				data: value.data
			});
			li.append(a);
			template = template.add(li);
		});

		ul.append(template).listview().appendTo('#sidemenu_content');
	};



///////////////////////////////////////////
// default header met aanroep
// naar eigen prog
///////////////////////////////////////////

	app.content_header = function(opts) {
		var options = $.extend({back:true, sidebar:false}, opts);																// default no back knop

		options.header = options.header || params['active_menu'].title;

		var template = "";
			template += '<div data-role="header" data-position="fixed">';
			template += '<h1>'+options.header+'</h1>';
			if (options.back !== false) {
				template += '<a href="#" data-icon="carat-l" data-theme="b" class="ui-btn-left  ui-nodisc-icon back-btn" data-iconpos="notext" data-rel="back"></a>';
			}
			if (options.sidebar !== false) {
				app.side_menu(options.sidebar_items);
				var icon = options.sidebar_icon ?  options.sidebar_icon : 'ui-icon-bars  ui-nodisc-iconui-btn-icon-notext';
				template  += '<a data-theme="b" class="sidebar-btn ui-btn ui-shadow ui-corner-all ui-icon-bars ui-btn-icon-notext ui-nodisc-icon '+icon+'" href="#side-menu"></a>';
			}

			if ($.isFunction(app.routes[params['hash']].header)) {
				template = app.routes[params['hash']].header(params, template);
			}
			template+= '</div> ';
		$(params['hash']).prepend(template).enhanceWithin();
	};

///////////////////////////////////////////
// default footer
///////////////////////////////////////////

	app.content_footer = function() {

		var footer = '';
		footer += '<div id="footer" data-role="footer" data-position="fixed" class="ui-bar">';
			footer += '<div data-role="navbar" data-grid="c">';
				footer += '<ul>';
				$.each(a_menu, function(key, value ) {

					var c_active=''

					if (('#'+value.id)==params['hash']) c_active = ' active';

					footer +='<li class="'+value.id+c_active+'" ><a href="#'+value.id+'">'+value.label+'</a></li>';
				});
				footer += '</ul>';
			footer += '</div>';
		footer += '</div>';
		$(params['hash']).append(footer).enhanceWithin();

	};


	function load_base_layers() {																					// default base layers to load
		layers.l [layers.l.length] = new ol.layer.Vector( {								is_ui:false, 						visible: true, m_key:'position_layer', source: new ol.source.Vector()});
		layers.l [layers.l.length] = new ol.layer.Tile({title: 'OpenStreetMap', 		is_base:true, m_key: 'osm',			preload: Infinity, is_not_delete:true, visible: true,	source: new ol.source.OSM()});
		layers.l [layers.l.length] = new ol.layer.Tile({title: 'EMODnet Bathymetry', 	is_base:true, m_key: 'emodnet_mean_land',		preload: Infinity, is_not_delete:true, visible: false,	source: new ol.source.TileWMS({ url: 'http://ows.emodnet-bathymetry.eu/wms', params: {layers:'emodnet:mean_atlas_land'}})});


	//	layers.l [layers.l.length] = new ol.layer.Tile({title: 'Bing', 					is_base:true, m_key: 'bing',		preload: Infinity, is_not_delete:true, visible: false,	source: new ol.source.BingMaps({ key: 'Ak-dzM4wZjSqTlzveKz5u0d4IQ4bRzVI309GxmkgSVr1ewS6iPSrOvOKhA-CJlm3',imagerySet: 'Road'})});
	//	layers.l [layers.l.length] = new ol.layer.Tile({title: 'Bing Aerial', 			is_base:true, m_key: 'bing_sat',	preload: Infinity, is_not_delete:true, visible: false,	source: new ol.source.BingMaps({ key: 'Ak-dzM4wZjSqTlzveKz5u0d4IQ4bRzVI309GxmkgSVr1ewS6iPSrOvOKhA-CJlm3',imagerySet: 'Aerial'})});
	//	layers.l [layers.l.length] = new ol.layer.Tile({title: 'Bing Aerial Labels',	is_base:true, m_key: 'bing_labels',	preload: Infinity, is_not_delete:true, visible: false,	source: new ol.source.BingMaps({ key: 'Ak-dzM4wZjSqTlzveKz5u0d4IQ4bRzVI309GxmkgSVr1ewS6iPSrOvOKhA-CJlm3',imagerySet: 'AerialWithLabels'})});
	}

	map_init = function (object, cb) {

		map_function_init_prefix();																					// exec all function as prefix

		load_base_layers();																							// load default layers

		load_layers_applic();																						// load application layers

		view_options = {
			projection: 'EPSG:3857',
			center:  new ol.proj.transform([33.211771, 35.036053], 'EPSG:4326','EPSG:3857'),
			zoom: 8
		};

		map_options = {target: object};

		map_function_init_suffix();																					// acex all function as suffix



		call(cb);

	};

///////////////////////////////////////////
// get_json
// from maris erver of seamobile server
///////////////////////////////////////////

	get_json = function(json_url, cb ) {

//		var url = 'http://194.42.21.85/SeaMobileWebServices/api/get_beaches/' + json_url;

//		if (!params.is_cordova) {
//			url='proxy.php?url='+url;
//		}

//		url =  proxy + 'http://apkseamobile.maris2.nl/get_data.php?version='+version+'&url='+json_url;
		url =  proxy + 'http://apkseamobile.maris2.nl/get_data.php?version='+version+'&rnd='+$.rnd()+'&url='+json_url;
//		url =  proxy + 'http://apk.seamobile/www/get_data.php?version='+version+'&url='+json_url;
		console.log("Get URL:", url);
		if (!is_cordova()) {
//			url = 'http://apk.seamobile/www/get_data.php?version='+version+'&url='+json_url;
		}

		if (is_cordova()) {
		//	url = 'http://apkseamobile.maris2000.nl/www/get_data.php?version='+version+'&url='+json_url;
		}
		if (json_url.substring(0,4)=='http') {																		// laat andere url toe in prog
			url = json_url;
			if (!is_cordova()) {
				url = 'maris_proxy.php?url='+json_url;																// only local wihtoud cordova
			}
		}


		$.getJSON( url, function( data ) {
			cb(data);
		})

		.fail(function(jqxhr, textStatus, error) {
			var err = textStatus + ", " + error;
			console.log( "Request Failed: " + err );
		})

	};

///////////////////////////////////////////
// Sticky first column
///////////////////////////////////////////

	sticky_column = function (container) {
		$(container)
			.find('table')
				.wrap($('<div>', {class: 'hidden-partition'}))
					.parent()
						.css({float: 'left'});

		var target = $(container).find('table').clone();

		target
			.addClass('sticky_header')
			.css({
				'pointer-events': 'none',
				position: 'absolute',
				marginLeft: -10,
				float: 'left'
			})
//				.one('taphold', function () {
//				target.remove();
//					$(container + ' table:not(.sticky_header)').one('taphold', function (){ sticky_column(container); });
//				})
		.find('td:not(:first-child)')				// every column except the first
			.css({
				visibility: 'hidden'
			});

		$(container).append(target);
		}


	window.osm_extra_layers = function (m_key) {
		var osm_index = layers.find_m_key('osm');
		if (osm_index === -1) {
			return ;
		}
		var osm_layer = layers.l[osm_index];
		var layer = new ol.layer.Tile({title: "OSM No Sea",visible: true, extent: new ol.proj.transformExtent([32.130, 34.497, 34.772, 35.751], 'EPSG:4326', 'EPSG:3857'),source: new ol.source.XYZ({url:proxy +'http://geoservice.maris2.nl/tiles/osm/osmnosea-bright/{z}/{x}/{y}.png'})});
		var layer_admin = new ol.layer.Tile({title: "OSM Admin",visible: true, extent: new ol.proj.transformExtent([32.130, 34.497, 34.772, 35.751], 'EPSG:4326', 'EPSG:3857'), is_base_static:true, source: new ol.source.XYZ({url:proxy +'http://geoservice.maris2.nl/tiles/osm/osm-noadmin/{z}/{x}/{y}.png'})});
		//var cyprusClipGeom = [[3587648.4091649936,4195150.79286976],[3612796.1500521386,4184351.6673256126],[3629306.500329143,4198415.993562531],[3654225.0343847447,4198263.179845799],[3665384.813336771,4224098.841902513],[3694583.8044523555,4218901.130963953],[3755198.3803842016,4224359.276993561],[3849521.6113231573,4275770.356756705],[3863891.73307017,4254826.595257874],[3793722.6052435385,4190726.9457133496],[3809927.272198824,4149343.518793351],[3774001.8008520557,4144298.638846041],[3711782.1091824616,4115864.0193546987],[3678149.8193460354,4099965.1718153334],[3660875.038125754,4101493.9074979816],[3606757.624274058,4124272.1402285183],[3587648.4091649936,4152095.147747826],[3584132.2717287964,4183281.468433536]];

		var cyprusClipGeom = [[3655524.440710269,4255402.238692334],[3876274.578397858,4307379.417926253],[3912964.351974743,4215043.487757758],[3802283.5350178075,4115369.6028738893],[3647574.9897686113,4070730.378355347],[3556462.052052681,4103139.678348262],[3546066.6162058967,4166123.7896552463],[3598043.7954398156,4230330.893414794],[3655524.440710269,4255402.238692334]];
		var borderClip = [[3935003.26381727,3733479.5093784155],[3974815.751228053,3865108.4355571303],[4017415.8336462565,4132158.6653185086],[3951945.249857305,4174669.142917614],[3799839.79849504,3973240.2652192744],[3839236.451555309,3768775.924538188],[3935003.26381727,3733479.5093784155]];

		var polygon = new ol.geom.Polygon([cyprusClipGeom]);
		var polygon_border = new ol.geom.Polygon([cyprusClipGeom]);


		if (m_key) {
			layers.insert_at(layers.find_m_key(m_key), layer_admin);
			layers.insert_at(layers.find_m_key(m_key), layer);
		} else {
			layers.add_layer(layer_admin);
			layers.add_layer(layer);
		}


		layer.bindTo('visible', osm_layer, 'visible');
		layer_admin.bindTo('visible', osm_layer, 'visible');

		layers.clip(layer_admin, polygon_border, {
			color: 'rgba(181, 208, 208, 1)',
			mask: true
		});
		layers.clip(layer, polygon);
	}

///////////////////////////////////////////
// String Helpers
///////////////////////////////////////////

	String.prototype.humanise = function() {
		return this.replace(/(?!^)[A-Z]/g, function (m) {return ' ' + m;}).replace(/_/g, ' ');
	}

	beach_title = function() {
		return params.beach.humanise()+', '+params.region.humanise()+'';
	}


})(m_application);

///////////////////////////////////////////
// map settings
///////////////////////////////////////////
