!(function (app) {

	app.content.beach_weather = function () {
		get_json_weather_table();
		app.content_header({header:beach_title()});
		app.content_footer();
	};

	function pad (str, max) {
	  str = str.toString();
	  return str.length < max ? pad("0" + str, max) : str;
	}


	function display_weather_table(result) {

		var content = '<table>';
			var content_date = '<tr class="heading"><td></td>'
			var content_time = '<tr><td class="time-label">Local time Cyprus</td>'

			var old='';
			var colspan=0;
			var h_date = '';
			var h_time = '';
			var temp_date = new Date()
			jQuery.each(result.list, function(index, day) {
				var date = new Date(day.dt*1000);
				h_time = date.getUTCHours()+utc_diff+'h';
				h_date = date.getUTCFullYear() + '-'+pad((date.getUTCMonth()+1),2)+'-'+pad(date.getUTCDate(),2);

				h_hour = date.getUTCHours()+utc_diff;
				if (h_hour > 24) {
					h_time = (date.getUTCHours()+utc_diff)-24+'h';
					temp_date.setDate(date.getUTCDate());
					temp_date.setFullYear(date.getUTCFullYear());
					temp_date.setMonth(date.getUTCMonth()+1);
					var tomorrow = temp_date;
					tomorrow.setDate(temp_date.getUTCDate()+1);
					h_date = tomorrow.getUTCFullYear() + '-'+pad(tomorrow.getUTCMonth(),2)+'-'+pad(tomorrow.getUTCDate(),2);
				}
				if (old!='' && old!=h_date) {
					content_date += '<td colspan="'+colspan+'">'+old+'</td>';
					old='';
					colspan=0;
				}
				colspan+=1;
				content_time += '<td>'+h_time+'</td>';
				old = h_date;
			});
			if (old!=''&& h_date!='') {
				content_date += '<td colspan="'+colspan+'">'+h_date+'</td>';
			}

			content += content_date;
			content += content_time;

			var lines  = {};

			lines.a_weather 		= '<td>Weather</td>';
			lines.b_temp			= '<td>Air&nbsp;temperature&nbsp;(&degC)</td>';
			lines.c_humidity	 	= '<td>Humidity&nbsp;(%)</td>';
			lines.d_wind_speed 		= '<td>Wind&nbsp;speed&nbsp;(m/s)</td>';
			lines.e_wind_deg 		= '<td>Wind&nbsp;direction&nbsp;(deg)</td>';
			lines.f_pressure 		= '<td>Air&nbsp;pressure&nbsp;(hpa)</td>';
			lines.g_rain 			= '<td>Rain&nbsp;(mm)</td>';

			jQuery.each(result.list, function(index, day) {
//				lines.a_weather 		+= '<td>'+day.clouds.all+'</td>';
				lines.a_weather 		+= '<td><img src="grfx/weather_icons/'+day.weather[0].icon+'.png"></td>';
				lines.b_temp			+= '<td>'+Math.round(day.main.temp)+'</td>';
				lines.c_humidity 		+= '<td>'+Math.round(day.main.humidity)+'</td>';
				lines.d_wind_speed 		+= '<td>'+Math.round(day.wind.speed)+'</td>';
				lines.e_wind_deg 		+= '<td>'+Math.round(day.wind.deg)+'</td>';
				lines.f_pressure 		+= '<td>'+Math.round(day.main.pressure)+'</td>';
				if (day.rain!=undefined) {
					if (day.rain['3h']!=undefined) {
						lines.g_rain += '<td>'+Math.round(day.rain['3h'])+'</td>';
					} else {
						lines.g_rain += '<td>&nbsp;</td>';
					}
				} else {
					lines.g_rain += '<td>&nbsp;</td>';
				}
			});

			jQuery.each(lines, function(index, value) {
				content += '<tr>'+ value + '</tr>';
			});

		content += '</table>';

		$('#beach_weather_content').html(content);

		sticky_column('#beach_weather_content');

	}
	function  get_json_weather_table (cb) {

		get_json('get_beach/'+params.region+'/'+params.beach, function (result) {
			var lat = result.Beach.Latitude;
			var lng = result.Beach.Longitude;
			get_json('http://api.openweathermap.org/data/2.5/forecast?APPID=02e50095472334a2f2b8adcdc3df8684&rnd='+$.rnd()+'&units=metric&lon='+lng.trim()+'&lat='+lat.trim(), function (result) {
//				 result = jQuery.parseJSON( '{"city":{"id":146278,"name":"Moutayiaka","coord":{"lon":33.099998,"lat":34.720829},"country":"CY","population":0,"sys":{"population":0}},"cod":"200","message":0.0132,"cnt":40,"list":[{"dt":1439596800,"main":{"temp":25.68,"temp_min":18.93,"temp_max":25.68,"pressure":982.33,"sea_level":1021.16,"grnd_level":982.33,"humidity":97,"temp_kf":6.75},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.91,"deg":290.005},"sys":{"pod":"n"},"dt_txt":"2015-08-15 00:00:00"},{"dt":1439607600,"main":{"temp":25.6,"temp_min":19.21,"temp_max":25.6,"pressure":982.42,"sea_level":1021.27,"grnd_level":982.42,"humidity":96,"temp_kf":6.39},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.82,"deg":283.003},"sys":{"pod":"n"},"dt_txt":"2015-08-15 03:00:00"},{"dt":1439618400,"main":{"temp":36.64,"temp_min":30.61,"temp_max":36.64,"pressure":983.26,"sea_level":1021.86,"grnd_level":983.26,"humidity":52,"temp_kf":6.04},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.85,"deg":285.504},"sys":{"pod":"d"},"dt_txt":"2015-08-15 06:00:00"},{"dt":1439629200,"main":{"temp":40.17,"temp_min":34.49,"temp_max":40.17,"pressure":983.14,"sea_level":1021.78,"grnd_level":983.14,"humidity":39,"temp_kf":5.68},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":3.92,"deg":288},"sys":{"pod":"d"},"dt_txt":"2015-08-15 09:00:00"},{"dt":1439640000,"main":{"temp":39.93,"temp_min":34.6,"temp_max":39.93,"pressure":982.65,"sea_level":1021.2,"grnd_level":982.65,"humidity":35,"temp_kf":5.33},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":4.86,"deg":290.501},"sys":{"pod":"d"},"dt_txt":"2015-08-15 12:00:00"},{"dt":1439650800,"main":{"temp":37.59,"temp_min":32.61,"temp_max":37.59,"pressure":982.33,"sea_level":1020.88,"grnd_level":982.33,"humidity":37,"temp_kf":4.97},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":4.57,"deg":294.002},"sys":{"pod":"d"},"dt_txt":"2015-08-15 15:00:00"},{"dt":1439661600,"main":{"temp":32.87,"temp_min":28.25,"temp_max":32.87,"pressure":982.69,"sea_level":1021.38,"grnd_level":982.69,"humidity":45,"temp_kf":4.62},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":2.55,"deg":298},"sys":{"pod":"n"},"dt_txt":"2015-08-15 18:00:00"},{"dt":1439672400,"main":{"temp":27.98,"temp_min":23.72,"temp_max":27.98,"pressure":983.22,"sea_level":1021.96,"grnd_level":983.22,"humidity":69,"temp_kf":4.26},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":2.16,"deg":298.008},"sys":{"pod":"n"},"dt_txt":"2015-08-15 21:00:00"},{"dt":1439683200,"main":{"temp":25.46,"temp_min":21.56,"temp_max":25.46,"pressure":982.74,"sea_level":1021.66,"grnd_level":982.74,"humidity":86,"temp_kf":3.91},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.91,"deg":305},"sys":{"pod":"n"},"dt_txt":"2015-08-16 00:00:00"},{"dt":1439694000,"main":{"temp":23.37,"temp_min":19.82,"temp_max":23.37,"pressure":983.23,"sea_level":1021.99,"grnd_level":983.23,"humidity":98,"temp_kf":3.55},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.96,"deg":309.003},"sys":{"pod":"n"},"dt_txt":"2015-08-16 03:00:00"},{"dt":1439704800,"main":{"temp":33.12,"temp_min":29.92,"temp_max":33.12,"pressure":983.78,"sea_level":1022.66,"grnd_level":983.78,"humidity":50,"temp_kf":3.2},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.5,"deg":294.003},"sys":{"pod":"d"},"dt_txt":"2015-08-16 06:00:00"},{"dt":1439715600,"main":{"temp":36.56,"temp_min":33.71,"temp_max":36.56,"pressure":983.87,"sea_level":1022.79,"grnd_level":983.87,"humidity":38,"temp_kf":2.84},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":3.57,"deg":261.001},"sys":{"pod":"d"},"dt_txt":"2015-08-16 09:00:00"},{"dt":1439726400,"main":{"temp":36.43,"temp_min":33.95,"temp_max":36.43,"pressure":983.46,"sea_level":1022.21,"grnd_level":983.46,"humidity":35,"temp_kf":2.49},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":4.47,"deg":262.501},"sys":{"pod":"d"},"dt_txt":"2015-08-16 12:00:00"},{"dt":1439737200,"main":{"temp":34.08,"temp_min":31.95,"temp_max":34.08,"pressure":983.01,"sea_level":1021.85,"grnd_level":983.01,"humidity":38,"temp_kf":2.13},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":3.96,"deg":265.004},"sys":{"pod":"d"},"dt_txt":"2015-08-16 15:00:00"},{"dt":1439748000,"main":{"temp":28.25,"temp_min":26.48,"temp_max":28.25,"pressure":983.52,"sea_level":1022.37,"grnd_level":983.52,"humidity":57,"temp_kf":1.78},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":2.11,"deg":275.501},"sys":{"pod":"n"},"dt_txt":"2015-08-16 18:00:00"},{"dt":1439758800,"main":{"temp":22.74,"temp_min":21.32,"temp_max":22.74,"pressure":983.69,"sea_level":1022.67,"grnd_level":983.69,"humidity":94,"temp_kf":1.42},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.66,"deg":281.007},"sys":{"pod":"n"},"dt_txt":"2015-08-16 21:00:00"},{"dt":1439769600,"main":{"temp":19.99,"temp_min":18.93,"temp_max":19.99,"pressure":983.15,"sea_level":1022.06,"grnd_level":983.15,"humidity":99,"temp_kf":1.07},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.12,"deg":304.001},"sys":{"pod":"n"},"dt_txt":"2015-08-17 00:00:00"},{"dt":1439780400,"main":{"temp":18.53,"temp_min":17.82,"temp_max":18.53,"pressure":982.89,"sea_level":1021.85,"grnd_level":982.89,"humidity":99,"temp_kf":0.71},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"02n"}],"clouds":{"all":8},"wind":{"speed":1.41,"deg":316.003},"sys":{"pod":"n"},"dt_txt":"2015-08-17 03:00:00"},{"dt":1439791200,"main":{"temp":27.7,"temp_min":27.34,"temp_max":27.7,"pressure":983.69,"sea_level":1022.54,"grnd_level":983.69,"humidity":65,"temp_kf":0.36},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.16,"deg":332.004},"sys":{"pod":"d"},"dt_txt":"2015-08-17 06:00:00"},{"dt":1439802000,"main":{"temp":32.79,"temp_min":32.79,"temp_max":32.79,"pressure":983.74,"sea_level":1022.78,"grnd_level":983.74,"humidity":44,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.21,"deg":172},"sys":{"pod":"d"},"dt_txt":"2015-08-17 09:00:00"},{"dt":1439812800,"main":{"temp":34.08,"temp_min":34.08,"temp_max":34.08,"pressure":982.74,"sea_level":1021.82,"grnd_level":982.74,"humidity":43,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.36,"deg":210.001},"sys":{"pod":"d"},"dt_txt":"2015-08-17 12:00:00"},{"dt":1439823600,"main":{"temp":33.04,"temp_min":33.04,"temp_max":33.04,"pressure":981.63,"sea_level":1020.87,"grnd_level":981.63,"humidity":43,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.46,"deg":226.017},"sys":{"pod":"d"},"dt_txt":"2015-08-17 15:00:00"},{"dt":1439834400,"main":{"temp":26.3,"temp_min":26.3,"temp_max":26.3,"pressure":982.54,"sea_level":1021.47,"grnd_level":982.54,"humidity":71,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":0.91,"deg":248.508},"sys":{"pod":"n"},"dt_txt":"2015-08-17 18:00:00"},{"dt":1439845200,"main":{"temp":22.31,"temp_min":22.31,"temp_max":22.31,"pressure":982.95,"sea_level":1021.83,"grnd_level":982.95,"humidity":86,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.92,"deg":331.513},"sys":{"pod":"n"},"dt_txt":"2015-08-17 21:00:00"},{"dt":1439856000,"main":{"temp":20.98,"temp_min":20.98,"temp_max":20.98,"pressure":982.68,"sea_level":1021.67,"grnd_level":982.68,"humidity":96,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":2.16,"deg":338.501},"sys":{"pod":"n"},"dt_txt":"2015-08-18 00:00:00"},{"dt":1439866800,"main":{"temp":20.01,"temp_min":20.01,"temp_max":20.01,"pressure":983.14,"sea_level":1021.93,"grnd_level":983.14,"humidity":100,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.96,"deg":333.501},"sys":{"pod":"n"},"dt_txt":"2015-08-18 03:00:00"},{"dt":1439877600,"main":{"temp":28.69,"temp_min":28.69,"temp_max":28.69,"pressure":983.82,"sea_level":1022.76,"grnd_level":983.82,"humidity":60,"temp_kf":0},"weather":[{"id":500,"main":"Rain","description":"light rain","icon":"10d"}],"clouds":{"all":0},"wind":{"speed":1.11,"deg":340.503},"rain":{"3h":0.025},"sys":{"pod":"d"},"dt_txt":"2015-08-18 06:00:00"},{"dt":1439888400,"main":{"temp":32.84,"temp_min":32.84,"temp_max":32.84,"pressure":984.13,"sea_level":1023.08,"grnd_level":984.13,"humidity":45,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.62,"deg":186},"rain":{},"sys":{"pod":"d"},"dt_txt":"2015-08-18 09:00:00"},{"dt":1439899200,"main":{"temp":34,"temp_min":34,"temp_max":34,"pressure":983.16,"sea_level":1022.45,"grnd_level":983.16,"humidity":42,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.66,"deg":215.5},"rain":{},"sys":{"pod":"d"},"dt_txt":"2015-08-18 12:00:00"},{"dt":1439910000,"main":{"temp":32.71,"temp_min":32.71,"temp_max":32.71,"pressure":982.63,"sea_level":1021.76,"grnd_level":982.63,"humidity":42,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":2.06,"deg":231.003},"rain":{},"sys":{"pod":"d"},"dt_txt":"2015-08-18 15:00:00"},{"dt":1439920800,"main":{"temp":25.7,"temp_min":25.7,"temp_max":25.7,"pressure":983.7,"sea_level":1022.59,"grnd_level":983.7,"humidity":69,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":0.96,"deg":260.002},"rain":{},"sys":{"pod":"n"},"dt_txt":"2015-08-18 18:00:00"},{"dt":1439931600,"main":{"temp":21.7,"temp_min":21.7,"temp_max":21.7,"pressure":984.45,"sea_level":1023.35,"grnd_level":984.45,"humidity":88,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":2.1,"deg":341.5},"rain":{},"sys":{"pod":"n"},"dt_txt":"2015-08-18 21:00:00"},{"dt":1439942400,"main":{"temp":20.14,"temp_min":20.14,"temp_max":20.14,"pressure":984.1,"sea_level":1023.18,"grnd_level":984.1,"humidity":99,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":2.31,"deg":345.001},"rain":{},"sys":{"pod":"n"},"dt_txt":"2015-08-19 00:00:00"},{"dt":1439953200,"main":{"temp":19.45,"temp_min":19.45,"temp_max":19.45,"pressure":984.6,"sea_level":1023.63,"grnd_level":984.6,"humidity":100,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":2.07,"deg":335.5},"rain":{},"sys":{"pod":"n"},"dt_txt":"2015-08-19 03:00:00"},{"dt":1439964000,"main":{"temp":27.88,"temp_min":27.88,"temp_max":27.88,"pressure":986.12,"sea_level":1025.05,"grnd_level":986.12,"humidity":61,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.16,"deg":319.507},"rain":{},"sys":{"pod":"d"},"dt_txt":"2015-08-19 06:00:00"},{"dt":1439974800,"main":{"temp":32.48,"temp_min":32.48,"temp_max":32.48,"pressure":986.37,"sea_level":1025.45,"grnd_level":986.37,"humidity":47,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.47,"deg":197.5},"rain":{},"sys":{"pod":"d"},"dt_txt":"2015-08-19 09:00:00"},{"dt":1439985600,"main":{"temp":33.99,"temp_min":33.99,"temp_max":33.99,"pressure":985.43,"sea_level":1024.68,"grnd_level":985.43,"humidity":42,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.36,"deg":192.503},"rain":{},"sys":{"pod":"d"},"dt_txt":"2015-08-19 12:00:00"},{"dt":1439996400,"main":{"temp":32.93,"temp_min":32.93,"temp_max":32.93,"pressure":984.91,"sea_level":1024.14,"grnd_level":984.91,"humidity":43,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01d"}],"clouds":{"all":0},"wind":{"speed":1.56,"deg":214.5},"rain":{},"sys":{"pod":"d"},"dt_txt":"2015-08-19 15:00:00"},{"dt":1440007200,"main":{"temp":25.92,"temp_min":25.92,"temp_max":25.92,"pressure":985.92,"sea_level":1025.06,"grnd_level":985.92,"humidity":73,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":1.07,"deg":302.504},"rain":{},"sys":{"pod":"n"},"dt_txt":"2015-08-19 18:00:00"},{"dt":1440018000,"main":{"temp":22.46,"temp_min":22.46,"temp_max":22.46,"pressure":986.55,"sea_level":1025.48,"grnd_level":986.55,"humidity":87,"temp_kf":0},"weather":[{"id":800,"main":"Clear","description":"sky is clear","icon":"01n"}],"clouds":{"all":0},"wind":{"speed":2.86,"deg":342.003},"rain":{},"sys":{"pod":"n"},"dt_txt":"2015-08-19 21:00:00"}]}');

				display_weather_table(result);
			});
		});

	}

})(m_application);
