!(function (app) {
	var dfd = null;

	app.content.marine_table = function () {
		dfd = $.Deferred();
		display_marine_table();
		app.content_header({header:beach_title()});
		app.content_footer();

	};


	// Show chart on click
	// date: 2015-08-20
	// beach: VrisiABeach
	// URL: http://194.42.21.85/SeaMobileWebServices/api/get_params/BeachVar?date={date}&beach={beach}

	function display_marine_table (cb) {
		var date = new Date().toISOString().slice(0, 10);
		get_json('http://194.42.21.85/SeaMobileWebServices/api/get_params/BeachVar?date='+date+'&beach='+params.beach, function (data) {dfd.resolve(data)});

		get_json('get_marine_table&region='+params.region+'&beach='+params.beach, function (result) {
			var content = '<table border="0">';

			content += result.header;

			content += '<tr>';
			$.each(result.sub_header, function(h_index, value) {
				content += '<td class="time-label">'+value+'</td>';
			});
			content += '</tr>';

				$.each(result.lines, function(l_index, lines) {
					content += '<tr>';
					if (lines.length < 3) {
						content += lines[0];
					} else {
						$.each(lines, function(dummy, value) {
							content += '<td>'+value+'</td>';
						});
					}
					content += '</tr>';
				});
			content += '</table>';

console.log(content);
			$('#marine_table_content').html(content);

			sticky_column('#marine_table_content');

			$('#marine_table_content > div > table tr:not(.heading, :has(td.category, td.time-label)) td:first-child').on('vclick', function (e) {
				var selected = this;




				dfd.then(function (data) {
					console.log('got answer',data);
					mapping_table = {
											'Current_speed_(m/s)': data.Current.Depth.values['0'].parameters.current_speed.times,
											'Current_speed_-5_m_(m/s)': data.Current.Depth.values['5'].parameters.current_speed.times
					};
					var chart_container = $('<div>', {
						id: 'chart_container',
						style: 'min-width: 310px; height: 400px; margin: 0 auto'
						});



					var data_obj = mapping_table[$(selected).text().replace(/\s/ig, '_')] || data.Winds.Air_Temperature_at_2m.times

					var labels = (function () {
							var count = 0;
							var label_times = $.map(data_obj, function(val, key) {return (count++)+':00'; });
							return label_times;
					}());

					chart_container.highcharts({
						title: {
							text: $(selected).text()
						},
						xAxis: {
							categories: labels
						},
						  series: [{
							name: 'Values',
							data: $.map(data_obj, function(val, key) { return val; })
        				}]
					});
					var overlay = new app.Overlay({content: chart_container});

					$(window).resize();
					console.log($(selected).text());


				});


			});

		});

	};

	get_json_temp = function(json_url, cb ) {

		url = proxy + "http://apkseamobile.maris2.nl/make_marine_info.php?beach="+params.beach;

		$.getJSON( url, function( data ) {
			cb(data);
		})

		.fail(function(jqxhr, textStatus, error) {
			var err = textStatus + ", " + error;
			console.log( "Request Failed: " + err );
		})

	};

})(m_application);
