!(function (app) {

	app.content.photo = function () {
		app.content_header({header: beach_title(),sidebar: false});
		app.content_footer();
		var beach_layer = null;
		var beach_source = null;
		var beaches  = [];
		var to_upload = null;
		var photo_form = {};
		var user_pos = {
			point_lng: 0,
			point_lat: 0,
			point_x_900913: 0,
			point_y_900913: 0
		};



		$(document).one('pagecontainertransition', function () {
			window.load_layers_applic = function () {
				//layers.l [layers.l.length] = new ol.layer.Image({title: "CURRENTS/sea_water_velocity/0", visible: true, opacity: 0.9, source: new ol.source.ImageWMS({url: 'maris_proxy.php?url=http://194.42.21.85/ncWMS/wms?', ratio: 1, params: { LAYERS: 'WAVES/waves', serverType: 'linda_gis' }})});
			};

			map_init('map_div_photo', function () {
				$('.user_location_btn').hide();

				var scroll_up_btn = function () {
					var this_ = this;
					var scroll_div = $('<div>', {
						class: 'map_scroll_btn ol-unselectable',
					});

					var scroll_icon = $('<a>').appendTo(scroll_div);

					scroll_div.on('click touchend', function (e) {
						e.preventDefault();
						$.mobile.silentScroll(0);
					});

					ol.control.Control.call(this_, {
						element: scroll_div[0],
						target: ''
					});

				};

				ol.inherits(scroll_up_btn, ol.control.Control);


				map.addControl(new scroll_up_btn());

				$('.map_scroll_btn a').show();
			});

			window.osm_extra_layers();

			function setup_dropdown (beaches) {
				return $.map(beaches.features, function (item) {
					return {
						title: item.properties.beach.humanise(),
						value: item.properties.beach
					};
				}).sort(function (a, b) {
						var al = a.value.toLowerCase();
						var bl = b.value.toLowerCase();
						var res = 0;
						if (al < bl) {
							res = -1;
						}else if (al > bl) {
							res = 1;
						}
						return res;
					});
			}
			function set_user_pos (coords) {
				var point_4326 = new ol.proj.transform(coords, 'EPSG:3857','EPSG:4326');
				user_pos = {
					point_lng: point_4326[0],
					point_lat: point_4326[1],
					point_x_900913: coords[0],
					point_y_900913: coords[1]
				};
			}
			function set_location (val) {

				var current_beach = beaches.features.filter(function (feature) {return feature.properties.beach == val;})[0];
				beach_source.clear();

				var coords = new ol.proj.transform(current_beach.geometry.coordinates, 'EPSG:4326', 'EPSG:3857');
				var f = new ol.Feature({
					geometry: new ol.geom.Point(coords)
				});

				beach_source.addFeature(f);
				set_user_pos(coords);
				var view = map.getView();
				view.setCenter(coords);
				view.setResolution(150);
			}

			if (params.region && params.beach) {
				get_json('geo_json_beach', function (result) {
					beaches = result;
					$('#beach_dropdown')
						.html(fill_select(setup_dropdown(beaches), null))
						.val(params.beach)
						.selectmenu('refresh')
						.on('change', function () {
							set_location($(this).val());
						});

					var current_beach = result.features.filter(function (feature) {return feature.properties.beach == params.beach;})[0];



					var beach = current_beach;
					var view = map.getView();
					var coords = new ol.proj.transform(current_beach.geometry.coordinates, 'EPSG:4326', 'EPSG:3857');

					view.setCenter(coords);
					view.setResolution(150);

					beach_source = new ol.source.Vector({
						features: [
							new ol.Feature({
								geometry: new ol.geom.Point(coords),
							})
						]
					});

					var style = [new ol.style.Style({
						image: new ol.style.Icon(({
							anchor: [13, 37],
							anchorXUnits: 'pixels',
							anchorYUnits: 'pixels',
							src: 'grfx/map_icon.png'
						}))
					})];

					beach_layer = new ol.layer.Vector({
						source: beach_source,
						style: style
					});



					layers.add_layer(beach_layer);


				});
			}


		});



		$('#camera_btn').on('vmousedown', function () {
			take_photo();
			StatusBar.hide();
		});
/*
		$('#photo_reset').on('vmousedown', function () {
				$('#photo_name, #photo_description').val('');
				to_upload = '';
		});

		*/

		$('#gallery_btn').on('vmousedown', function () {
			get_photo();
			StatusBar.hide();
		});

		$('#photo_submit').on('vmousedown', function () {
			$(this).off();
			send_form();
		});

	function get_photo(cb) {
		navigator.camera.getPicture(on_success, on_fail, {
			quality: 55,
			destinationType: Camera.DestinationType.FILE_URI,
			sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
			targetWidth: 1024,
			targetHeight: 1024,
			correctOrientation: true
		});

		function on_success(response) {
			//$('#form_foto_image_preview').html('<img class="image_preview" src="'+response+'" />');

			to_upload = response;
			StatusBar.hide();
			cb && cb();
			if (is_cordova() && device.model.match(/ipad/i)) {
				$('.ui-footer').css('bottom', $(window).height() - ($.is_landscape() ? 768 : 1024));
			}
		}

		function on_fail(error) {
			//alert('Failed because: ' + error);
			StatusBar.hide();
			if (is_cordova() && device.model.match(/ipad/i)) {
				$('.ui-footer').css('bottom', $(window).height() - ($.is_landscape() ? 768 : 1024));
			}
		}
	}

	function take_photo(cb) {
		navigator.camera.getPicture(on_success, on_fail, {
			quality: 55,
			destinationType: Camera.DestinationType.FILE_URI,
			sourceType: Camera.PictureSourceType.CAMERA,
			targetWidth: 1024,
			targetHeight: 1024,
			correctOrientation: true
		});

		function on_success(response) {
			//$('#form_foto_image_preview').html('<img class="image_preview" src="'+response+'" />');
			to_upload = response;
			StatusBar.hide();
			cb && cb();
			if (is_cordova() && device.model.match(/ipad/i)) {
				$('.ui-footer').css('bottom', $(window).height() - ($.is_landscape() ? 768 : 1024));
			}
		}

		function on_fail(error) {
		//	alert('Failed because: ' + error);
			StatusBar.hide();
			if (is_cordova() && device.model.match(/ipad/i)) {
				$('.ui-footer').css('bottom', $(window).height() - ($.is_landscape() ?  768 : 1024));
			}
		}


	}


	function reset_form () {
	 	photo_form = {};
		user_pos = {
			point_lng: 0,
			point_lat: 0,
			point_x_900913: 0,
			point_y_900913: 0
		};
	}

	var on_success = $.noop;
	var onfail = $.noop;

	function send_form () {
		var error = [];

		photo_form = {
			name: $('#photo_name').val(),
			description: $('#photo_description').val(),
			beach: $('#beach_dropdown').val(),
			email: 'none@none.nl'
		};


		if (photo_form.email.trim() == '') {
			error.push('E-Mail is empty');
		}

		if (!photo_form.email.match(/[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/)) {

			error.push('Not a valid E-Mail address');
		}

		if (photo_form.name.trim() == '') {
			error.push('Your name is empty');
		}

		if (photo_form.description.trim() == '') {
			error.push('Description is empty');
		}

		if (to_upload.trim() == '') {
			error.push('No photo to upload');
		}


		if (error.length > 0) {
			$('#photo_submit').on('vmousedown', function () {
				$(this).off();
				send_form();
			});
			
			return mobile_alert({
				message: error.join("\n"),
				cb:null,
				title:'Errors',
				button:'Ok'
			});

			// alert('Errors: \n' + error.join('\n'));
		}



		$.extend(photo_form, user_pos);


		function on_success(r) {

			// go('photos', {
			// 	beach: $('#beach_dropdown').val()
			// });
			go('html', {
				html: 'upload_success'
			});
		}
		function on_fail (r){
			$('#photo_submit').on('vmousedown', function () {
				$(this).off();
				send_form();
			});
		};
		var uri = encodeURI(proxy + "http://apkseamobile.maris2000.nl/www/apk_foto.php");
		 uri = encodeURI(proxy + "http://apkseamobile.maris2.nl/apk_foto.php");
		var options = new FileUploadOptions();
		options.fileKey = "file";
		options.mimeType = "image/jpeg";
		options.params = photo_form;
		options.headers = {};
		options.chunkedMode = false;

		var ft = new FileTransfer();
		u = to_upload;
		options.fileName = u.substr(u.lastIndexOf('/') + 1);
		ft.upload(u, uri, on_success, on_fail, options);
	}

	};









})(m_application);
