//---------------------------------------------
// maris default ol3 map_function
//---------------------------------------------

var map;																										// the map object
var layers;																										// all the layers
var popup;																										// popup used with wfs actions
var hover_info;																									// hover_info of the map
var grfx_directory;																								// grfx directory of the images of the vector layer
var icon_size;																									// icons size of the vector layer
var show_position = false;																						// aan of uit staan van show position
var show_position_box_id = '#show_position_box';																// id of the position box to show the mouse position
var decimal_places = 6;																							// in gebruik voor afronding
var show_measure = false;																						// aan of uit measure
var show_bounding_box = false;																						// aan of uit measure
var show_measure_box_id = '#show_measure_box';																	// id of the measure box to show
var measure_layer;
var drag_to_zoom = false;																						// wel of niet drag to zoom
var identify = false																							// if identify is active
var getfeature_layer;																							// active layer for get_feature
var layer_container_base_title = '<h4>Base layers</h4>';														// title base layers
var layer_container_title = '<h4>Predefined layers</h4>';													// title layers
var mlb_lightbox;																								// m(aris)l(ight)b(ox)_lightbox var
var size_layer_window_correction = 100;																			// getal aanpassing tov map-window
var info_format_type_defaults = [																				// default format_types t.b.v add external layer
	'text/xml', 'text/html','text/json'
	];
var mlb_lightbox_defaults = {																					// mlb_lightbox defaults
	'width':'400',
	'height':'200',
	'title':'Default title Lightbox',
	'content':'Default content Lightbox',
	'iframe':''

};

var mlb_lightbox_iframe_options =  {																			// vb. data-iframe_options=\'{"height":"100%", "css":{"marginLeft": "100px"}}\'
		scrolling: 'yes',
		width:	   '100%',
		height:		'90%',
		border:		0,
		frameborder: 0
};
var external_layer_defaults = {																					// defaults settings for add external layer
	'ratio' : 1,
	'visible' : true,
	'opacity' : 0.8,
	'info_format_type':'text/html',																				// default text/html terug
	'server_type' : 'mapserver',																				// server type, ol3 intern gebruik
	'is_not_info' : false
//	'getfeature_url' : ''																						// getfeature url alleen indien anders dan wms url nog niet actief
};

var view_options = {};																							// application options view
var view_options_defaults = {																					// default view
		projection: 'EPSG:900913',
		center:  new ol.proj.transform([0, 0], 'EPSG:4326','EPSG:3857'),
		zoom: 1
	};
var map_options = {};																							// application optiosn map
var map_options_defaults = {																					// default map
		target: 'map',
		controls: [],
		interactions: ol.interaction.defaults({altShiftDragRotate: false, pinchRotate: false})
	};

var layers_ui;																									// pointer to class



var style = new ol.style.Style({																				// style of the vector layers icons
	image:  new ol.style.Icon(({src:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNgYAAAAAMAASsJTYQAAAAASUVORK5CYII="}))
});

var geojson_style = function (f, resolution) {																	// style needed for vector layers
	return styles;
};

var styles = [style];

var zoom_levels = {
	0: 156412,
	1: 78206,
	2: 39103,
	3: 19551,
	4: 9776,
	5: 4888,
	6: 2444,
	7: 1222,
	8: 610.984,
	9: 305.482,
	10: 152.746,
	11: 76.373,
	12: 38.187,
	13: 19.093,
	14: 9.547,
	15: 4.773,
	16: 2.387,
	17: 1.193,
	18: 0.596,
	19: 0.298
}

function append_grfx (grfx, append, icon) {																		// grfx needed for vector layers
	return grfx.slice(0,-1) + append + "/" + icon;;
};


function rnd() {																								// rnd function
	var dd=new Date();
	return((Math.round(Math.abs(Math.sin(dd.getTime()))*1000000000)));
}

//---------------------------------------------
// find_my_current_location
//---------------------------------------------

function find_my_current_location (cb) {
	navigator.geolocation.getCurrentPosition(function (position){
		var destination = new ol.proj.transform([position.coords.longitude, position.coords.latitude],'EPSG:4326', 'EPSG:3857');
		var pan = ol.animation.pan({
		  source: map.getView().getCenter(),
		  duration: 250,
		  easing: ol.easing.easeOut
		});
		map.beforeRender(pan);
		map.getView().setCenter(destination);
		(cb && cb(destination));
	});
}


//---------------------------------------------
// default base layers
//---------------------------------------------

function load_base_layers(base_layer) {																					// default base layers to load

//---------------------------------------------
// maris extra settings
// title				naam van de layer
// is_base 				boolean wel of geen bassis kaart
// is_not_delete		boolean wel of niet delete (pas op precies andersom) gedaan omdat default delete is
// is_query_layer		wel of niet getfeature
// is_not_ui			boolean wel of niet show in interace (pas op precies andersom) gedaan omdat default show is.
// is_not_info			boolean wel of niet info button in interace (pas op precies andersom) gedaan omdat default show is.
// info_formatter		function b.v. info_formatter: new_formatter (let op geen string gebruiken)
// info_format_type		text/xml text/html application/json 	of eigen 	default text/xml
// getfeature_url		url voor de getfeature optie, allen geven indien anders dan layer url
// m_key				internal maris key
//---------------------------------------------
// pas op ze worden reverse geladen

	base_layer = base_layer || 'BA';
	base_layer = base_layer.toUpperCase();

	layers.l [layers.l.length] = new ol.layer.Tile({title: 'OpenStreetMap', 		m_key:'openstreetmap', 		is_base:true,	is_not_delete:true, visible: 'O' == base_layer,	source: new ol.source.OSM()});
	layers.l [layers.l.length] = new ol.layer.Tile({title: 'Bing', 					m_key:'bing', 				is_base:true,	is_not_delete:true, visible: 'B' == base_layer,	source: new ol.source.BingMaps({ key: 'ArJ-y77nassq9l6rLD3WU1HA61Dqij4BfkgVjPyvF2-Sfc1AWKp73NAhbJcr0cri',imagerySet: 'Road'})});
	layers.l [layers.l.length] = new ol.layer.Tile({title: 'Bing Aerial', 			m_key:'bing_aerial', 		is_base:true,	is_not_delete:true, visible: 'BA' == base_layer,	source: new ol.source.BingMaps({ key: 'ArJ-y77nassq9l6rLD3WU1HA61Dqij4BfkgVjPyvF2-Sfc1AWKp73NAhbJcr0cri',imagerySet: 'Aerial'})});
	layers.l [layers.l.length] = new ol.layer.Tile({title: 'Bing Aerial Labels',	m_key:'bing_aerial_labels', is_base:true,	is_not_delete:true, visible: 'BAL' == base_layer,	source: new ol.source.BingMaps({ key: 'ArJ-y77nassq9l6rLD3WU1HA61Dqij4BfkgVjPyvF2-Sfc1AWKp73NAhbJcr0cri',imagerySet: 'AerialWithLabels'})});

}


//---------------------------------------------
// all active geojson features
//---------------------------------------------

function vector_layer_active(cb) {																				// active vevtor layers
	$.each(layers.get_layers(), function (index, item) {
		var vector_events = {};
		if (item.get('is_geojson') === true) {
				vector_events[index] = item.getSource().on('change', function(e){
					if (this.getState() == 'ready') {
						var feature_layer = this;
						var count = 0;
						feature_layer.unByKey(vector_events[index]);
						if (cb) {
							feature_layer.forEachFeature(cb);
						}
					}
				});
		}
	});


}

//---------------------------------------------
// all active geojson layers
//---------------------------------------------
function geojson_loaded(cb, filters) {																// jQuery Deferred objects
	var vector_events = {};																	// Uses promises wait for the ready state of the layers
	var deferreds ={};
	if (!filters) {
		filters = false;
	}

	var check_filter = function (item) {
		if (!filters) {
			return true;
		}

		for(var i = 0; i < filters.length; i++) {
			if (item.get(filters[i]) !== true) {
				return false;
			}
		}
		return true;
	};

	$.each(layers.get_layers(), function (index, item) {
		if (item.get('is_geojson') === true) {
			if (!check_filter(item)) return;

			deferreds[index] = $.Deferred();
				if (item.getSource().getState() != 'ready') {
					vector_events[index] = item.getSource().on('change', function(e){
						if (this.getState() == 'ready') {
							this.unByKey(vector_events[index]);
							deferreds[index].resolve();
						}
					});
				} else {
					deferreds[index].resolve();
				}
		}
	});
//	console.log(deferreds);
	$.when.apply(null, $.map(deferreds, function (el) {										// Only fires if all promises are resolved
		return el.promise();
	})).then(cb || $.noop);																	//$.noop is default empty function: function {}
}


//---------------------------------------------
// Get current scale
//---------------------------------------------
function get_scale () {
// http://gis.stackexchange.com/questions/132200/relationship-between-scale-ppi-and-map-resolution
// http://www.supermap.com/EN/online/iClient%206R/iClient%206R%20for%20Ajax/WebHelp/G_MapAndLayer/E_ResolutionAndScale.html
// https://groups.google.com/forum/#!msg/ol3-dev/RAJa4locqaM/Tg-JQ9L_YeMJ
// http://wiki.openstreetmap.org/wiki/Zoom_levels
// Map scale = 1 : (ScreenRes pixels/inch * 39.37 inches/meter * 156543.04 meters/pixel * cos(latitude) / (2 ^ zoomlevel))

	var view = map.getView();
	var resolution = view.getResolution();																		// meters per pixel
	var units = view.getProjection().getUnits();																// meter per unit
	var dpi = 25.4 / 0.28;
	var mpu = ol.proj.METERS_PER_UNIT[units];
	var scale = resolution * mpu * 39.37 * dpi;
	return scale;
}



//---------------------------------------------
// zoom by level function
//---------------------------------------------

function zoom_level(level, _options) {
	var default_options = {
		duration: 500
	};

	var options = $.extend({}, default_options, _options);
	var zoom = ol.animation.zoom({
	  resolution: map.getView().getResolution(),
	  duration: options.duration,
	  easing: ol.easing.easeOut
	});
	map.beforeRender(zoom);
	map.getView().setResolution(zoom_levels[level]);

}



//---------------------------------------------
// zoom in function
//---------------------------------------------

function zoom_in(map) {
	var zoom = ol.animation.zoom({
	  resolution: map.getView().getResolution(),
	  duration: 250,
	  easing: ol.easing.easeOut
	});
	map.beforeRender(zoom);
	map.getView().setResolution(map.getView().constrainResolution(map.getView().getResolution(),1));
}

//---------------------------------------------
// zoom out function
//---------------------------------------------

function zoom_out(map) {
	var zoom = ol.animation.zoom({
	  resolution: map.getView().getResolution(),
	  duration: 250,
	  easing: ol.easing.easeOut
	});
	map.beforeRender(zoom);
	map.getView().setResolution(map.getView().constrainResolution(map.getView().getResolution(),-1));
}

//---------------------------------------------
// reset to full extend
//---------------------------------------------

function reset_extent (map) {
	var view = map.getView();

	view.setCenter(view_options.center);
	view.setResolution(view_options.resolution);

}


//---------------------------------------------
// activate then popup info_window overlay
//---------------------------------------------

function act_popup_window() {

	if (!$("#popup" ).length) return;																			// indien geen popup nodig dan return

	popup = popup_window({'container': $('#popup')});

	overlay_popup = new ol.Overlay({
	  element: $('#popup'),
	  positioning: 'bottom-center',																				// positie tov de mouseclick
	  stopEvent: true
	});

	map.addOverlay(overlay_popup);
}

//---------------------------------------------
// show feature details WMS/WFS
//---------------------------------------------

function show_feature_details(e) {
	var pixel = e.pixel;
	var feature = map.forEachFeatureAtPixel(pixel, function(feature, layer) {
		return feature;
	});
	if ( feature ) {
		$('#popup_content').html(feature.get('content'));
		$('#popup_content').data('extra', feature.get('extra'));
		if (popup) {
			popup.show(e);
		}

	}
}

//---------------------------------------------
// popup window over the map
//---------------------------------------------

function popup_window () {
	var that = {};

	var show = function (event){

		overlay_popup.setPosition(event.coordinate);
		$('#popup').show();

		var padding_left 	= 10;
		var padding_top 	= 20;
		var offset_left 	= 0;
		var offset_top 		= 0;
		var duration		= 600;

		var popup_width 	= $('#popup').outerWidth(true);
		var popup_height	= $('#popup').outerHeight(true);
		var map_size		= map.getSize();

		var left 			= event.pixel[0] - offset_left 		- (popup_width/2) 	- padding_left;
		var right 			= event.pixel[0] + (popup_width/2) 	+ padding_left;
		var top 			= event.pixel[1] - offset_top		- popup_height 		- padding_top;

		var pixel_center = map.getPixelFromCoordinate(map.getView().getCenter());
		var pan = ol.animation.pan({
	   	 	duration: duration,
	   		source: map.getView().getCenter()
	 	 });
	 	var must_pan = false;
	 	var pan_to = pixel_center;
		if (left < 0) {
			must_pan = true;
			pan_to[0] = pan_to[0] + left;
		}

		if (top < 0) {
			must_pan = true;
			pan_to[1] = pan_to[1] + top;
		}

		if (right > map_size[0]) {
			must_pan = true;
			pan_to[0] = pan_to[0] + (right-map_size[0]);
		}

		if (must_pan) {
			 map.beforeRender(pan);
			 map.getView().setCenter(map.getCoordinateFromPixel(pan_to));
		}
	};

	var close = function () {
		$('#popup').html();
		$('#popup').hide();
	};
	that.close = close;
	that.show = show;

	return that;
}

//---------------------------------------------
// mlb Maris Light Box
//---------------------------------------------

function mlb_lightbox_window (options) {

	var that = {};

	that.visible = false;

	var mlb_overlay = $('<div id="mlb_overlay" class="mlb-deactive"></div>');									// div t.b.v afschermen achtergrond

	var init = function (){
		$('body').append(mlb_overlay);
	}
	init();

	var resize = function (width,height) {
		if (width!=undefined) {
			$("#mlb_container").css("width", width);
			$("#mlb_container").css("left", (($(window).width()-width)/2)+'px');
		}
		if (height!=undefined) {
			$("#mlb_container").css("height", height);
			$("#mlb_container").css("top", (($(window).height()-height)/2)+'px');
		}
	}

	var show = function (options){

		options =  $.extend({}, mlb_lightbox_defaults, options || {});											// add defaults to settings

		var iframe_options = $.extend({}, mlb_lightbox_iframe_options, options.iframe_options || {});

		$('html').addClass('no_scroll');																		// set scrolling off

		resize(options.width,options.height);																	// resize the div


		$("#mlb_title").html(options.title);																	// set the title
		$("#mlb_content").html(options.content);																// set the content

		if (options.iframe!=undefined) {																		// create iframe if requested
			$('<iframe>', $.extend({
				src: options.iframe,
				id:  'mlb-iframe'
			   }, iframe_options)).appendTo('#mlb_content');													// see default
		} else {
		}

		$('.mlb_close').on('click',function (e) {																// activate close button
			close();
		});

		$("#mlb_overlay").show() ;																				// achtergrond blokkeren
		$("#mlb_container").show();																				// show lightbox

		that.is_visible = true;

	};

	var close = function () {																					// close function
		$('html').removeClass('no_scroll');																		// remove noscrolling
		$("#mlb_container").hide();																				// hide lightbox
		$("#mlb_overlay").hide() ;																				// achtergrond vrijgeven
		clear();																								// clear the html and title
		that.is_visible = false;
	};

	var clear = function () {																					// clear function
		$("#mlb_title").html('');
		$("#mlb_content").html('');
	}

	var is_visible = function () {																				// is visible function
		return that.is_visible;
	}

	return {
		init : init,																							// make public
		is_visible:is_visible,
		show : show,
		close: close

	};
}


function show_feature_infowindow(event) {																		// show get_feature
	var pixel = map.getEventPixel(event);
	var feature = map.forEachFeatureAtPixel(pixel, function(feature, layer) {
		return feature;
	});

	if (feature) {

		$('#map').css('cursor', 'pointer');


		if (feature.get('function') == 2 && feature.get('icon').indexOf('keuzepunt_') == 0) {
			return;
		}

		if (selected_feature != feature ) {
			var naam = feature.get('naam');
			hover_info.setPosition(feature.getGeometry().getCoordinates());
			$('#hover_info').html(naam);
		}

		if ($(hover_info.getElement()).is(':hidden')) {
			if(!$(hover_info.getElement()).is(':animated')) {
				$(hover_info.getElement()).fadeIn();
			}
		}

	} else {
		$('#map').css('cursor', '');
		$(hover_info.getElement()).fadeOut();
	}
	selected_feature = feature;

}


//---------------------------------------------
// show the position of the mouse
/// 20150414 build to wgs84
//---------------------------------------------

function show_position_box (event) {
	if (event) {
//		$(show_position_box_id).html(Number(event.coordinate[0]).toFixed(decimal_places)+" , "+ Number(event.coordinate[1]).toFixed(decimal_places));
		var wgs84 = new ol.proj.transform(event.coordinate, 'EPSG:3857','EPSG:4326');
		$(show_position_box_id).html(Number(wgs84[1]).toFixed(decimal_places)+" , "+ Number(wgs84[0]).toFixed(decimal_places));

	}
}

//---------------------------------------------
// format  data from getfeature
// default is 'text/xml'
//---------------------------------------------

function xml_formatter(data) {
	var xml_doc = $(data);																						// load data
	if (!xml_doc.length) {
		xml_doc = $($.parseXML(data));																			// parse data
	}
	return printable_xml(xml_doc);
};

//---------------------------------------------
// format  data from getfeature (html)
//---------------------------------------------

function html_formatter(data) {
	return $(data);																								// just return
};

//---------------------------------------------
// format  data from getfeature (json)
//---------------------------------------------
function json_formatter(data) {
	return $('<pre>').text(JSON.stringify(data, null, 2));														// print nice json
};

//---------------------------------------------
// show identify_box on map
//---------------------------------------------

function show_identify_box(event)  {

	popup.close();																								// close the popup window if open

	if (event) {
		if (getfeature_layer!=undefined) {
			var layer_to_query = layers.l[getfeature_layer];
			if (layer_to_query.getVisible()) {

				var url = show_identify_box_url(event,layer_to_query);											// create idenitfy url for this layer

				if (url) {																						// test url
					$.get(url, function (data) {																// get the url
						var formatted_data = '';
						if (layer_to_query.get('info_formatter') &&  $.isFunction(layer_to_query.get('info_formatter'))) {
							formatted_data = layer_to_query.get('info_formatter')(data);
						} else {
							switch (layer_to_query.get('info_format_type')) {
								case 'application/json':
									if (data.length || $.isPlainObject(data)) {									// isplain werkt voor 1 object
										formatted_data = json_formatter(data);
									} else {
										data = '';
									}

									break;
								case 'text/html':
									formatted_data = html_formatter(data);
									break;
								default:
									formatted_data = xml_formatter(data);
									break;
								}
						}

						if (data !== '') {
							$("#popup_content").html(formatted_data);
							popup.show(event);																	// deze aanroep voor show t.b.v. positionering
					}
					});
				}
			}
		}

	}

}

function show_identify_box_url(event, layer_to_query)  {

	var view = map.getView();
	var viewResolution = (view.getResolution());
	var info_format_type = layer_to_query.get('info_format_type') || 'text/xml';
	var url = layer_to_query.getSource().getGetFeatureInfoUrl(event.coordinate, viewResolution, view.getProjection(), {'INFO_FORMAT': info_format_type});
	return url;
}
//---------------------------------------------
// make xml to printable html
//---------------------------------------------
function printable_xml (xml) {

	var to_jquery = $('<div>').append(xml.clone().valueOf());
	var pre		= $('<pre>').text(to_jquery.html());
	return $('<div>').append(pre).html();
}

//---------------------------------------------
// activate one tool option in toolbar
//
// add class = tool-active
//---------------------------------------------

function activate_one_tool(p) {
	$(p).addClass('tool-active');
}

//---------------------------------------------
// de-activate one tool option in toolbar
//
// remove class = tool-active
//---------------------------------------------

function deactivate_one_tool(p) {
	$(p).removeClass('tool-active');
}

//---------------------------------------------
// measure distance
//---------------------------------------------

var sketch;
var sketch_element;


      var wgs84Sphere = new ol.Sphere(6378137);

var measure_handler = function (e) {
	if (sketch) {
		var output;
		var geom = (sketch.getGeometry());
		if (geom instanceof ol.geom.Polygon) {
			output = geom;
		} else {
			output = geom;

// bb 20160822 	nodig voor afstand hemelsbreed

			  var coordinates = geom.getCoordinates();
			  var length = 0;
			  var sourceProj = map.getView().getProjection();
			  for (var i = 0, ii = coordinates.length - 1; i < ii; ++i) {
				var c1 = ol.proj.transform(coordinates[i], sourceProj, 'EPSG:4326');
				var c2 = ol.proj.transform(coordinates[i + 1], sourceProj, 'EPSG:4326');
				length += wgs84Sphere.haversineDistance(c1, c2);
			  }

// afstand over de weg.
//			var length = Math.round(geom.getLength() * 100) / 100;

			$(show_measure_box_id).html(length > 100 ? (Math.round(length / 1000 * 100) / 100) + ' ' + 'km': (Math.round(length * 100) / 100) +' ' + 'm');			// empty html
		}
	}
};

var measure_source = new ol.source.Vector();

measure_layer = new ol.layer.Vector({
	source: measure_source,
	is_not_ui: true,
	style: new ol.style.Style({
		fill: new ol.style.Fill({
			color: 'rgba(255, 255, 255, 0.2)'
		}),
		stroke: new ol.style.Stroke({
			color: '#ffcc33',
				width: 2
		}),
		image: new ol.style.Circle({
			radius: 7,
			fill: new ol.style.Fill({
				color: '#ffcc33'
			})
		})
	})
});


var drag_zoom = new ol.interaction.DragZoom({
	condition: function (a){return drag_to_zoom}
});

var bounding_box = new ol.interaction.DragBox({
	condition: ol.events.condition.always,
	    style: new ol.style.Style({
	        stroke: new ol.style.Stroke({
	            color: [0,0,255,1]
	        })
    })
});


var draw = new ol.interaction.Draw({
	source: measure_source,
	type: 'LineString'
});

draw.on('drawstart', function (e) {
	sketch = e.feature;
});
draw.on('drawend', function (e) {
	sketch = null;
}, this);




//---------------------------------------------
// object to array
//---------------------------------------------

function $o2a(o) {
	$a = new Array();
	for (var key in o) {
		$a.push(o[key]);
	}
	return $a;
}


//---------------------------------------------
// layer list
//---------------------------------------------

function create_layer_list() {

	var c_temp='';
	var checked = 'checked';																					// eerste is_query_laag altijd aan

	var l_len = layers.get_layers().length - (1 + layers.count('is_not_ui', true));

	function draw_layer_control(index,	item) {
		index = l_len - index;
		var c_temp = '';
		var l_wms_wfs = '';
		var l_transparent = '';
		var l_delete = '';
		var l_display = '';
		var l_info = '';

		if (item.get('is_query_layer') === true) {
			l_wms_wfs = '<div class="input-type-radio"><input class="getfeature_layer_btn" '+checked+' type="radio" name="ml_query_layer" value="'+index+'" /><span></span></div>';
			if (checked!='') {
				checked = '';																					// eerste laag altijd checked
				getfeature_layer = index;																		// zet deze layers aan
			}
		}

		if (item.get('m_transparent') !== false) {
			l_transparent = '<input type="range" id="l_slider_'+index+'" name="ml_range_slider" min="0" max="1" step="0.1" value="0.1" data-index="'+index+'" />';
		}

		l_display = '<label><div><input '+(item.getVisible() ?"checked=checked": "")+' type="checkbox" id="l_display_'+index+'" value="'+index+'"><span></span></div>'+item.get('title')+'</label>';

		if (!item.get('is_not_info')) {
			l_info = '<span class="info_layer_btn info-layer-btn" data-layer="'+index+'" data-width="500" data-height="300" data-func="layer_info" data-title="Info layer"></span>';
	}

		if (!item.get('is_not_delete')) {
			l_delete = '<span class="delete_layer_btn delete-layer-btn" data-index="'+index+'"></span>';
		}

		c_temp='';
		c_temp+='<li data-index="'+index+'")>';																	// index number layer
			c_temp+='<table border="0">';
				c_temp+='<tr>';
					c_temp+='<td class="container-input">'+l_wms_wfs+'</td>';									// wfs
					c_temp+='<td class="container-input">'+l_display+'</td>';									// checkbox for display swap plus name of layer
					c_temp+='<td>'+l_info+'</td>';																// info button
					c_temp+='<td>'+l_delete+'</td>';															// delete button
				c_temp+='</tr>';
				c_temp+='<tr>';
					c_temp+='<td colspan="10">'+l_transparent+'</td>';											// slider transparency
			c_temp+='</table>';
		c_temp+='</li>'

		var li = $(c_temp);																						// zet om naar object

		$('#layer_container'+(item.get('is_base') ? "_base":"")).append(li);									// append to container (or base)

		if ($('#l_display_'+index).length != 0) {
			new ol.dom.Input(document.getElementById('l_display_'+index)).bindTo('checked', item, 'visible');	// bind to layer display
		}
		if ($('#l_slider_'+index).length != 0) {
			new ol.dom.Input(document.getElementById('l_slider_'+index)).bindTo('value', item, 'opacity');		// bind to layer opacity
		}

	}

	$('#layer_container_base').html(layer_container_base_title);												// reset layer_container_base with nothing  plus title
	$('#layer_container').html(layer_container_title);															// reset layer_container width nothing plus title


	$.each (layers.get_layers().filter(function(n){ return !n.get('is_not_ui');}).slice().reverse(), draw_layer_control);		// loop all layers

	act_layer_buttons();																						// activate layer buttons info and delete

}

//---------------------------------------------
// activate default layer buttons
//---------------------------------------------

function act_layer_buttons() {

	$('.info_layer_btn').click(function() {																		// activate info buttons
		mlb_lightbox.show($(this).data());
	});

	$('.delete_layer_btn').click(function() {																	// activate delete buttons
		layers.remove_layer($(this).data('index'));
	});

	$('.getfeature_layer_btn').click(function() {																// activate getfeature buttons
		popup.close();
		getfeature_layer = $(this).val();
	});
}

//---------------------------------------------
// sortable function actual action
//---------------------------------------------
function sort_init () {
	$( "#layer_container" ).sortable({
		items: "> :not(h4)",
		stop: function( event, ui ) {
			var ui_layers = $('#layer_container li');
			var new_index =  ((ui_layers.size() - (1)) - ui_layers.index(ui.item)) + layers.count('is_base', true);	// Reverse index
			layers.set_at(new_index, ui.item.data('index'));
		}
	}
	);
	/*
	$( "#layer_container" ).disableSelection();
	$( "#layer_container_base" ).disableSelection();
	*/

	$( "#layer_container" )
			.css({
				'-moz-user-select': 'none',
				'-ms-user-select': 'none',
				'-webkit-user-select': 'none'
			})
			.find('input')
				.css({
					'-moz-user-select': 'text',
					'-ms-user-select': 'text',
					'-webkit-user-select': 'text'
				});

		$( "#layer_container_base")
			.css({
				'-moz-user-select': 'none',
				'-ms-user-select': 'none',
				'-webkit-user-select': 'none'
			})
			.find('input')
				.css({
					'-moz-user-select': 'text',
					'-ms-user-select': 'text',
					'-webkit-user-select': 'text'
				});




	$( "#layer_container_base" ).sortable({
		items: "> :not(h4)",
		stop: function( event, ui ) {
			var ui_layers = $('#layer_container_base li');
			var new_index =  ((ui_layers.size() - (1)) - ui_layers.index(ui.item));	// Reverse index
			layers.set_at(new_index, ui.item.data('index'));
		}
	}
	);
}




//---------------------------------------------
// add_control																									// add a user control to the map
//---------------------------------------------

function add_control (element) {
	var control_box = function () {
		ol.control.Control.call(this, {
				element: element[0]
		});
	};

	ol.inherits(control_box, ol.control.Control);

	map.addControl(new control_box());
}

//---------------------------------------------
// add_external_layer
//---------------------------------------------

function add_external_layer(options) {

	layer =  $.extend({}, external_layer_defaults, options || {});												// add defaults to settings

	layers.add_layer_at(new ol.layer.Image({title: layer.Title, info_format_type:layer.info_format_type, is_not_info: layer.is_not_info, is_query_layer: true, visible: layer.visible, opacity: layer.opacity, source: new ol.source.ImageWMS  ({serverType: layer.server_type, url: layer.url, ratio: layer.ratio,params: { LAYERS: layer.Name    }})}));
}

//---------------------------------------------
// resize the height of the layer window
//---------------------------------------------

function resize_layer_window() {

		var new_height = map.getSize()[1]-size_layer_window_correction;											// calc new height
		if (new_height > 0) {
			$('#content_layers').height(new_height);
		}
}



//---------------------------------------------
//	Debug map container size
//---------------------------------------------

function activate_debug_border(_num) {
	var num = _num || 1;
	$(map.getTargetElment()).css({
		border: '1px solid red',
		'box-sizing': 'border-box'
	});
}


//---------------------------------------------
//	Debug polygon
//---------------------------------------------

function activate_debug_polygon(cords, transform, flip) {
	var opposite = '';
	if (transform == 'EPSG:4326') {
		opposite = 'EPSG:3857';
	} else {
		transform = 'EPSG:3857';
		opposite = 'EPSG:4326';
	}

	var poly =  new ol.geom.Polygon([(flip) ?cords.map(function(c){return new ol.proj.transform(c,transform, opposite);}) : cords]);
	var ploy_feature = new ol.Feature({
		geometry: poly
	});

	layers.add_layer(new ol.layer.Vector({source: new ol.source.Vector({features: [ploy_feature]})}));
	console.log('Original:', JSON.stringify(cords));
	console.log('Transformed('+opposite+'):', JSON.stringify(cords.map(function(c){return new ol.proj.transform(c,transform, opposite);})));

}






//---------------------------------------------
// init of map_functions
//---------------------------------------------

function map_function_init_prefix() {

	layers_ui = function () {
		var that = {};
		var layers = [];


		function reverse() {
			var base = that.l.filter(function(l){ return true ? l.get('is_base') : !l.get('is_base'); });
			var regular = that.l.filter(function(l){ return false ? l.get('is_base') : !l.get('is_base'); });

			that.l = [].concat(base.reverse(), regular.reverse());
			return that.l;
		}

		var get_layers = function () {

			return that.l;																						// nu worden layers in source volgorde
		};


		var remove_layer = function (index) {																	// remove layer with index number
			map.removeLayer(that.l[index]);																		// remove from map
			that.l = map.getLayers().getArray().slice();
			create_layer_list()

		};


		var set_at =  function (new_index, index) {																// index = huidige index|  new_index = gewenste index
			var layer_to_swap = map.getLayers().item(index);													// save layer

			map.removeLayer(layer_to_swap);
			map.getLayers().insertAt(new_index, layer_to_swap);												    // insert layer on new place


			that.l = map.getLayers().getArray().slice();														// fill array with new layers
			create_layer_list()																					// display layers in list
		};

		var add_layer = function (ol_layer) {
			if (ol_layer) {
				that.l.push(ol_layer);																			// add to array
				map.addLayer(ol_layer);																			// add to map
			}

			create_layer_list()
		};

		var add_layer_at = function (ol_layer) {

			map.getLayers().insertAt(that.count('is_not_ui'), ol_layer);										// add to map
			that.l = map.getLayers().getArray().slice();
			create_layer_list()
		};


		var  count = function (prop, status) {
			return that.l.filter(function(l){ return status ? l.get(prop) : !l.get(prop); }).length;
		}

		var find_m_key = function (prop) {																			//verlopig een
			for (var i = 0; i < that.l.length; i++ ) {
				if (that.l[i].get('m_key') == prop) {
					return i;
				}
			}
			return -1;
		}


		that.l = layers;
		that.reverse = reverse;
		that.get_layers = get_layers;
		that.remove_layer = remove_layer;
		that.add_layer = add_layer;
		that.add_layer_at = add_layer_at;
		that.set_at = set_at;
		that.count = count;
		that.find_m_key = find_m_key;
		return that;

	};

	layers = new layers_ui(map);

	sort_init();
}


//---------------------------------------------
// init_suffix of map_functions
//---------------------------------------------

function map_function_init_suffix() {

	view_options = $.extend({}, view_options_defaults, view_options);

	var view = new ol.View(view_options);

	view_options.resolution = view.getResolution();																// haal resolution from map and save in view_options, voor max_extend

	map_options  = $.extend({}, map_options_defaults, {
			layers: layers.reverse(layers.get_layers()),
			view: view
	}, map_options);



	map = new ol.Map(map_options);

	layers.add_layer(measure_layer);																			// add measure layer


	act_popup_window();																							// activate popup info_window

	mlb_lightbox = mlb_lightbox_window();

	$(map.getViewport()).on('mousemove', measure_handler);														// activeer mousemove op measure_handeler


//---------------------------------------------
// buttons to activate
//---------------------------------------------

	$('.act_mlb_lightbox').click(function() {																	// activate mlb_function
		mlb_lightbox.show($(this).data());
	});

	$('#popup_close').on('click',function (e) {																	// activate close button
		popup.close();
	});

	$('#identify_button').click(function() {																	// activate mlb_function
		if (!identify) {
			activate_one_tool(this);
			identify = true;
		} else {
			popup.close();
			deactivate_one_tool(this);
			identify = false;
		}
	});

	$("#zoom_in").click(function () {																			// zoom in button
		zoom_in(map);
	});

	$("#zoom_out").click(function () {																			// zoom out button
		zoom_out(map);
	});

	$("#zoom_to_extent").click(function () {																	// zoom to extend
		reset_extent(map);
	});

	$("#drag_to_zoom").click(function () {																		// drag to zoom
		if (!drag_to_zoom) {
			drag_to_zoom = true;
			activate_one_tool(this);
		} else {
			drag_to_zoom = false;
			deactivate_one_tool(this);
		}
		map.addInteraction(drag_zoom);
	});

	$("#show_position").click(function () {																		// show position

		if (!show_position) {
			show_position = true;
			activate_one_tool(this);
			show_position_box();
			$('#show_position_box').show();
		} else {
			show_position = false;
			deactivate_one_tool(this);
			$(show_position_box_id).html('&nbsp;');																// empty html
			$('#show_position_box').hide();
		}
	});


	$("#measure_button").click(function () {																	// measure button
		if (!show_measure) {
			show_measure = true;
			activate_one_tool(this);
			map['addInteraction'](draw);
			$('#show_measure_box').show();
		} else {
			show_measure = false;
			deactivate_one_tool(this);
			$(show_measure_box_id).html('&nbsp;');																// empty html
			measure_layer.getSource().clear();																	// clear all objects ofn this  layer
			map['removeInteraction'](draw);
			$('#show_measure_box').hide();
		}
	});

	map.on('pointermove', function (event){																		// mouse event on map
		if (show_position) {
			show_position_box(event);																			// postition of map
		}
	});

	$('#bounding_box').on('click', function () {
		activate_one_tool(this);
		if (!show_bounding_box) {
			show_bounding_box = true;
			map.addInteraction(bounding_box);
		} else {
			show_bounding_box = false;
			deactivate_one_tool(this);
			 map.removeInteraction(bounding_box);

		}
	});




	map.on('singleclick', function (event) {

		if (identify) {																							// idenity not active
			show_identify_box(event)
		}

	});


	if ($('#show_measure_box').size()) {																		// test if exists div
		add_control($('#show_measure_box'));
	}

	if ($('#show_position_box').size()) {																		// test if exists div
		add_control($('#show_position_box'));
	}


	window.onresize = function() {																				// aanpassen layout layers adhv kaart height en allen bij event resize amp
		resize_layer_window();
	}

	resize_layer_window();																						// height afhankelijkk van kaart height

	$(window).resize();																							// start event for ie11 show layer
}

