//---------------------------------------------
// map_function_mobile
//---------------------------------------------

//---------------------------------------------
// init of map_functions
//---------------------------------------------

var user_icon = [new ol.style.Style({
	image:  new ol.style.Icon(({
		anchor: [0.5, 0.5],
		anchorXUnits: 'fraction',
		anchorYUnits: 'fraction',
		src: 'grfx/my_location_big.png'
		}))
})];

function show_identify_box_url(event, layer_to_query, _options)  {
	var options  = $.extend({}, _options);
	var view = map.getView();
	var viewResolution = (view.getResolution());
	var info_format_type = layer_to_query.get('info_format_type') || 'text/xml';
	var url = layer_to_query.getSource().getGetFeatureInfoUrl(event.coordinate, viewResolution, options.projection || view.getProjection(), {'INFO_FORMAT': info_format_type});
	return url;
}

function map_function_init_prefix() {

	layers_ui = function () {
		var that = {};
		var layers = [];


		function reverse() {
			var base = that.l.filter(function(l){ return true ? l.get('is_base') : !l.get('is_base'); });
			var regular = that.l.filter(function(l){ return false ? l.get('is_base') : !l.get('is_base'); });

			that.l = [].concat(base.reverse(), regular.reverse());
			return that.l;
		}

		var get_layers = function () {

			return that.l;																						// nu worden layers in source volgorde
		};

		var remove_layer = function (index) {																	// remove layer with index number
			map.removeLayer(that.l[index]);																		// remove from map
			that.l = map.getLayers().getArray().slice();
			create_layer_list()

		};


		var set_at =  function (new_index, index) {																// index = huidige index|  new_index = gewenste index
			var layer_to_swap = map.getLayers().item(index);													// save layer

			map.removeLayer(layer_to_swap);
			map.getLayers().insertAt(new_index, layer_to_swap);												    // insert layer on new place


			that.l = map.getLayers().getArray().slice();														// fill array with new layers
			create_layer_list()																					// display layers in list
		};

		var clip = function ( layer, feature, _options) {

				var options = $.extend({}, {
					color: [0,0,0,0],
					mask: false
				}, _options);


				var fillStyle = new ol.style.Fill({color: options.color});

				if (options.mask) {
					layer.on('precompose', function(event) {
						var context = event.context;
						var vectorContext = event.vectorContext;
						context.save();
						vectorContext.setFillStrokeStyle(new ol.style.Fill({color: [0,0,0,0]}), null);
						vectorContext.drawPolygonGeometry(feature, null);
						context.clip();
					});

					layer.on('postcompose', function(event) {
						var context = event.context;
						var vectorContext = event.vectorContext;
						event.context.restore();
						context.save();
						vectorContext.setFillStrokeStyle(fillStyle, null);
						vectorContext.drawPolygonGeometry(feature, null);
						context.clip();
						event.context.restore();
					});

				} else {

					layer.on('precompose', function(event) {
						var context = event.context;
						var vectorContext = event.vectorContext;
						context.save();
						vectorContext.setFillStrokeStyle(fillStyle, null);
						vectorContext.drawPolygonGeometry(feature, null);
						context.clip();
					});

					layer.on('postcompose', function(event) {
						event.context.restore();
					});

				}



			};

		var add_layer = function (ol_layer) {
			if (ol_layer) {
				that.l.push(ol_layer);																			// add to array
				map.addLayer(ol_layer);																			// add to map
			}

			create_layer_list()
		};

		var find_m_key = function (prop) {																			//verlopig een
			for (var i = 0; i < that.l.length; i++ ) {
				if (that.l[i].get('m_key') == prop) {
					return i;
				}
			}
			return -1;
		}


		var add_layer_at = function (ol_layer) {

			map.getLayers().insertAt(that.count('is_not_ui'), ol_layer);										// add to map
			that.l = map.getLayers().getArray().slice();
			create_layer_list()
		};

		var insert_at = function (index, ol_layer) {
			map.getLayers().insertAt(index, ol_layer);										// add to map
			that.l = map.getLayers().getArray().slice();
			create_layer_list()
		};


		var  count = function (prop, status) {
			return that.l.filter(function(l){ return status ? l.get(prop) : !l.get(prop); }).length;
		}


		that.l = layers;
		that.reverse = reverse;
		that.get_layers = get_layers;
		that.remove_layer = remove_layer;
		that.add_layer = add_layer;
		that.insert_at = insert_at;
		that.add_layer_at = add_layer_at;
		that.set_at = set_at;
		that.count = count;
		that.clip = clip;
		that.find_m_key = find_m_key;
		return that;

	};

	layers = new layers_ui(map);

//	sort_init();
}




//---------------------------------------------
// init_suffix of map_functions
//---------------------------------------------

function map_function_init_suffix() {

	view_options = $.extend({}, view_options_defaults, view_options);

	var view = new ol.View(view_options);

	view_options.resolution = view.getResolution();																// haal resolution from map and save in view_options, voor max_extend

	userlocationbtn = function () {
		var anchor_userlocation = $('<a>');
		var element_userlocation = $('<div>').addClass('user_location_btn ol-unselectable');


		anchor_userlocation.on('click touchend', function(e) {
			e.preventDefault();

			find_my_current_location (function (location900913) {

				console.log(layers.find_m_key('position_layer'));
				var idx = layers.find_m_key('position_layer');

				layers.l[idx].getSource().clear();
				var f = new ol.Feature({
					geometry: new ol.geom.Point(
						location900913
					)
				});

				f.setStyle(user_icon);
				layers.l[idx].getSource().addFeature(f);

			});
		});


		element_userlocation.append(anchor_userlocation);

		ol.control.Control.call(this, {
			element: element_userlocation[0],
			target: ''
		});

	}

	ol.inherits(userlocationbtn, ol.control.Control);
	console.log(map_options);

	map_options  = $.extend({}, map_options_defaults, {
			layers: layers.reverse(layers.get_layers()),
			controls: [new userlocationbtn()],
			view: view
	}, map_options);

	map = new ol.Map(map_options);

	console.log(map);

	layers.add_layer(measure_layer);																			// add measure layer


	act_popup_window();																							// activate popup info_window

//	mlb_lightbox = mlb_lightbox_window();

//	$(map.getViewport()).on('mousemove', measure_handler);														// activeer mousemove op measure_handeler


//---------------------------------------------
// buttons to activate
//---------------------------------------------

	$('#popup_close').on('click',function (e) {																	// activate close button
		popup.close();
	});


	map.on('singleclick', function (event) {

		if (identify) {																							// idenity not active
			show_identify_box(event)
		}

	});


	$(window).resize();
}


/*
function old_map_init() {
	overlay = overlay_window();

	hover_info = new ol.Overlay({
		element: $('#hover_info'),
		positioning: 'bottom-center',				// positie tov de mouseclick
		stopEvent: false
	});

	layers = new layersUI(map);


	act_layers();

	var view = new ol.View({
		projection: 'EPSG:3857',
		center:  new ol.proj.transform([33.211771, 35.036053], 'EPSG:4326','EPSG:3857'),
		zoom: 8
	});

	var userlocationbtn = function () {
	var anchor_userlocation = $('<a>').html("Mijn locatie");
	var element_userlocation = $('<div id="bert12">').addClass('user_location_btn').addClass('ol-unselectable');
	var this_ = this;

	anchor_userlocation.on('touchend', function(e) {
			e.preventDefault();

			find_my_current_location (function (location900913) {
				layers.l['marker_layer'].getSource().clear();
				var f = new ol.Feature({
						geometry: new ol.geom.Point(
							location900913
						)
					});

				f.setStyle(user_icon);
				layers.l['marker_layer'].getSource().addFeature(f);

				});
			});



	element_userlocation.append(anchor_userlocation);
	ol.control.Control.call(this, {
		element: element_userlocation[0],
		target: ''
	});

	}
	var kaartbeheerbtn = function () {
		var anchor_kaarbeheer = $('<a>').html("Kaartbeheer");
		var element_kaarbeheer = $('<div>', {class: 'kaart_beheer_btn ol-unselectable'});
		var this_ = this;
		anchor_kaarbeheer.on('touchend', function(e) {
			e.preventDefault();
			var content = $('<div>')
			.append('<div class="mobile_expand_content_title">Kaartbeheer</div>')
			.append(wandel_layer_ui());

			m_application.Overlay({content: content, class: ['kaartbeheer']});
	});




	element_kaarbeheer.append(anchor_kaarbeheer);
	ol.control.Control.call(this, {
		element: element_kaarbeheer[0],
		target: ''
	});

	}


	ol.inherits(userlocationbtn, ol.control.Control);
	ol.inherits(kaartbeheerbtn, ol.control.Control);

	map = new ol.Map({
		target: 'map_div_'+params.hash.substring(1),
		//controls: [new userlocationbtn(), new kaartbeheerbtn()],
		controls: [],
		interactions: ol.interaction.defaults({altShiftDragRotate: false, pinchRotate: false}),
		pixelRatio:1,				//Stop newer phones using native pixel ratios moreinfo: http://bjango.com/articles/min-device-pixel-ratio/
		layers:
			layers.get_layers(),
		view: view
	});


	last_resolution = view.getResolution();

	show_layers_ui();

	act_buttons();

	map.addOverlay(hover_info);

	if (window['map_action_applic']) {
		map_action_applic();
	}

	vector_layer_active();
	act_popup_window();																		// activate popup info_window

	if (window['act_document_ready']) {
		act_document_ready();
	}

	map.on(['click','touchend'], function (event){
		show_feature_details(event);
	});


	map.getView().on("change:resolution", changed_zoom);
	changed_zoom({target:{getResolution:function(){return view.getResolution()}}});

	$("#popup").on('click touchend', '.lb_ext_link', function (e) {
		popup.close();
	});
	$("#popup").on('click touchend', '.lb_link, .lb_ext_link', function (e) {
		if ($(this).attr('href') == '#') {
			e.preventDefault();
			e.stopPropagation();
		} else {
			e.preventDefault();
			e.stopPropagation();
			var $this = $(this);
			var target = '_system';
			window.open($this.attr('href'), target, 'location=yes');
		}


		popup.close();
		//var params = $("#popup_content").data('extra');
	});
}

*/